submodule: use prepare_submodule_repo_env consistently
[git/git.git] / git-submodule.sh
CommitLineData
70c7ac22
LH
1#!/bin/sh
2#
4c8a9db6 3# git-submodule.sh: add, init, update or list git submodules
70c7ac22
LH
4#
5# Copyright (c) 2007 Lars Hjemli
6
1d5bec8b 7dashless=$(basename "$0" | sed -e 's/-/ /')
681b036f 8USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
64b19ffe 9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
1d5bec8b 10 or: $dashless [--quiet] init [--] [<path>...]
cf419828 11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
893a9764 12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--checkout|--merge|--rebase] [--reference <repository>] [--recursive] [--] [<path>...]
adc54235 13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
15fc56a8 14 or: $dashless [--quiet] foreach [--recursive] <command>
82f49f29 15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
8f321a39 16OPTIONS_SPEC=
091a6eb0 17SUBDIRECTORY_OK=Yes
70c7ac22 18. git-sh-setup
d0ad8251 19. git-sh-i18n
98fcf840 20. git-parse-remote
70c7ac22 21require_work_tree
091a6eb0
JK
22wt_prefix=$(git rev-parse --show-prefix)
23cd_to_toplevel
70c7ac22 24
33cfccbb
JK
25# Restrict ourselves to a vanilla subset of protocols; the URLs
26# we get are under control of a remote repository, and we do not
27# want them kicking off arbitrary git-remote-* programs.
28#
29# If the user has already specified a set of allowed protocols,
30# we assume they know what they're doing and use that instead.
31: ${GIT_ALLOW_PROTOCOL=file:git:http:https:ssh}
32export GIT_ALLOW_PROTOCOL
33
5c08dbbd 34command=
ecda0723 35branch=
d27b876b 36force=
d92a3959 37reference=
70c7ac22 38cached=
48bb3033
GP
39recursive=
40init=
1c244f6e 41files=
06b1abb5 42remote=
31ca3ac3 43nofetch=
32948425 44update=
15fc56a8 45prefix=
73b0898d 46custom_name=
275cd184 47depth=
70c7ac22 48
967b2c66
JS
49# The function takes at most 2 arguments. The first argument is the
50# URL that navigates to the submodule origin repo. When relative, this URL
51# is relative to the superproject origin URL repo. The second up_path
52# argument, if specified, is the relative path that navigates
53# from the submodule working tree to the superproject working tree.
54#
55# The output of the function is the origin URL of the submodule.
56#
57# The output will either be an absolute URL or filesystem path (if the
58# superproject origin URL is an absolute URL or filesystem path,
59# respectively) or a relative file system path (if the superproject
60# origin URL is a relative file system path).
61#
62# When the output is a relative file system path, the path is either
63# relative to the submodule working tree, if up_path is specified, or to
64# the superproject working tree otherwise.
f31a522a
ML
65resolve_relative_url ()
66{
98fcf840 67 remote=$(get_default_remote)
8e7e6f39 68 remoteurl=$(git config "remote.$remote.url") ||
4d689320 69 remoteurl=$(pwd) # the repository is its own authoritative upstream
f31a522a 70 url="$1"
99b120af 71 remoteurl=${remoteurl%/}
ea640cc6 72 sep=/
967b2c66
JS
73 up_path="$2"
74
75 case "$remoteurl" in
76 *:*|/*)
77 is_relative=
78 ;;
758615e2
JS
79 ./*|../*)
80 is_relative=t
81 ;;
967b2c66
JS
82 *)
83 is_relative=t
758615e2 84 remoteurl="./$remoteurl"
967b2c66
JS
85 ;;
86 esac
87
f31a522a
ML
88 while test -n "$url"
89 do
90 case "$url" in
91 ../*)
92 url="${url#../}"
ea640cc6
TR
93 case "$remoteurl" in
94 */*)
95 remoteurl="${remoteurl%/*}"
96 ;;
97 *:*)
98 remoteurl="${remoteurl%:*}"
99 sep=:
100 ;;
101 *)
758615e2
JS
102 if test -z "$is_relative" || test "." = "$remoteurl"
103 then
104 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
105 else
106 remoteurl=.
107 fi
ea640cc6
TR
108 ;;
109 esac
f31a522a
ML
110 ;;
111 ./*)
112 url="${url#./}"
113 ;;
114 *)
115 break;;
116 esac
117 done
758615e2
JS
118 remoteurl="$remoteurl$sep${url%/}"
119 echo "${is_relative:+${up_path}}${remoteurl#./}"
f31a522a
ML
120}
121
091a6eb0
JK
122# Resolve a path to be relative to another path. This is intended for
123# converting submodule paths when git-submodule is run in a subdirectory
124# and only handles paths where the directory separator is '/'.
125#
126# The output is the first argument as a path relative to the second argument,
127# which defaults to $wt_prefix if it is omitted.
128relative_path ()
129{
130 local target curdir result
131 target=$1
132 curdir=${2-$wt_prefix}
133 curdir=${curdir%/}
134 result=
135
136 while test -n "$curdir"
137 do
138 case "$target" in
139 "$curdir/"*)
140 target=${target#"$curdir"/}
141 break
142 ;;
143 esac
144
145 result="${result}../"
146 if test "$curdir" = "${curdir%/*}"
147 then
148 curdir=
149 else
150 curdir="${curdir%/*}"
151 fi
152 done
153
154 echo "$result$target"
155}
156
be9d0a3a
HV
157die_if_unmatched ()
158{
159 if test "$1" = "#unmatched"
160 then
161 exit 1
162 fi
163}
164
88ce00c3
TK
165#
166# Print a submodule configuration setting
167#
168# $1 = submodule name
169# $2 = option name
170# $3 = default value
171#
172# Checks in the usual git-config places first (for overrides),
173# otherwise it falls back on .gitmodules. This allows you to
174# distribute project-wide defaults in .gitmodules, while still
175# customizing individual repositories if necessary. If the option is
176# not in .gitmodules either, print a default value.
177#
178get_submodule_config () {
179 name="$1"
180 option="$2"
181 default="$3"
182 value=$(git config submodule."$name"."$option")
183 if test -z "$value"
184 then
185 value=$(git config -f .gitmodules submodule."$name"."$option")
186 fi
187 printf '%s' "${value:-$default}"
188}
189
862ae6cd
RS
190isnumber()
191{
192 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
193}
194
14111fc4
JK
195# Sanitize the local git environment for use within a submodule. We
196# can't simply use clear_local_git_env since we want to preserve some
197# of the settings from GIT_CONFIG_PARAMETERS.
198sanitize_submodule_env()
199{
200 sanitized_config=$(git submodule--helper sanitize-config)
201 clear_local_git_env
202 GIT_CONFIG_PARAMETERS=$sanitized_config
860cba61 203 export GIT_CONFIG_PARAMETERS
14111fc4
JK
204}
205
ecda0723
SV
206#
207# Add a new submodule to the working tree, .gitmodules and the index
208#
ec05df35 209# $@ = repo path
ecda0723
SV
210#
211# optional branch is stored in global branch variable
212#
23a485e3 213cmd_add()
ecda0723 214{
5c08dbbd 215 # parse $args after "submodule ... add".
091a6eb0 216 reference_path=
5c08dbbd
JH
217 while test $# -ne 0
218 do
219 case "$1" in
220 -b | --branch)
221 case "$2" in '') usage ;; esac
222 branch=$2
223 shift
224 ;;
d27b876b
JL
225 -f | --force)
226 force=$1
227 ;;
5c08dbbd 228 -q|--quiet)
2e6a30ef 229 GIT_QUIET=1
5c08dbbd 230 ;;
d92a3959
MT
231 --reference)
232 case "$2" in '') usage ;; esac
091a6eb0 233 reference_path=$2
d92a3959
MT
234 shift
235 ;;
236 --reference=*)
091a6eb0 237 reference_path="${1#--reference=}"
d92a3959 238 ;;
73b0898d
JL
239 --name)
240 case "$2" in '') usage ;; esac
241 custom_name=$2
242 shift
243 ;;
275cd184
FG
244 --depth)
245 case "$2" in '') usage ;; esac
246 depth="--depth=$2"
247 shift
248 ;;
249 --depth=*)
250 depth=$1
251 ;;
5c08dbbd
JH
252 --)
253 shift
254 break
255 ;;
256 -*)
257 usage
258 ;;
259 *)
260 break
261 ;;
262 esac
263 shift
264 done
265
091a6eb0
JK
266 if test -n "$reference_path"
267 then
268 is_absolute_path "$reference_path" ||
269 reference_path="$wt_prefix$reference_path"
270
271 reference="--reference=$reference_path"
272 fi
273
ecda0723 274 repo=$1
64394e3a 275 sm_path=$2
ecda0723 276
64394e3a 277 if test -z "$sm_path"; then
6a066230 278 sm_path=$(printf '%s\n' "$repo" |
1414e578
JL
279 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
280 fi
281
496eeeb1 282 if test -z "$repo" || test -z "$sm_path"; then
ecda0723
SV
283 usage
284 fi
285
091a6eb0
JK
286 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
287
ec05df35
ML
288 # assure repo is absolute or relative to parent
289 case "$repo" in
290 ./*|../*)
091a6eb0
JK
291 test -z "$wt_prefix" ||
292 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
293
ec05df35
ML
294 # dereference source url relative to parent's url
295 realrepo=$(resolve_relative_url "$repo") || exit
296 ;;
297 *:*|/*)
298 # absolute url
299 realrepo=$repo
300 ;;
301 *)
497ee872 302 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
ec05df35
ML
303 ;;
304 esac
305
db75ada5
MG
306 # normalize path:
307 # multiple //; leading ./; /./; /../; trailing /
64394e3a 308 sm_path=$(printf '%s/\n' "$sm_path" |
db75ada5
MG
309 sed -e '
310 s|//*|/|g
311 s|^\(\./\)*||
8196e728 312 s|/\(\./\)*|/|g
db75ada5
MG
313 :start
314 s|\([^/]*\)/\.\./||
315 tstart
316 s|/*$||
317 ')
64394e3a
RJ
318 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
319 die "$(eval_gettext "'\$sm_path' already exists in the index")"
ecda0723 320
64394e3a 321 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
d27b876b 322 then
6ff875c5 323 eval_gettextln "The following path is ignored by one of your .gitignore files:
64394e3a 324\$sm_path
6ff875c5 325Use -f if you really want to add it." >&2
d27b876b
JL
326 exit 1
327 fi
328
73b0898d
JL
329 if test -n "$custom_name"
330 then
331 sm_name="$custom_name"
332 else
333 sm_name="$sm_path"
334 fi
335
d4264ca3 336 # perhaps the path exists and is already a git repo, else clone it
64394e3a 337 if test -e "$sm_path"
d4264ca3 338 then
496eeeb1 339 if test -d "$sm_path"/.git || test -f "$sm_path"/.git
d4264ca3 340 then
64394e3a 341 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
d4264ca3 342 else
64394e3a 343 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
d4264ca3 344 fi
c2f93917 345
d4264ca3 346 else
4b7c286e
JL
347 if test -d ".git/modules/$sm_name"
348 then
349 if test -z "$force"
350 then
351 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
352 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
353 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
354 echo >&2 " $realrepo"
355 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
356 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
357 else
358 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
359 fi
360 fi
d10e3b42 361 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$wt_prefix" --path "$sm_path" --name "$sm_name" --url "$realrepo" ${reference:+"$reference"} ${depth:+"$depth"} || exit
d851ffb9 362 (
14111fc4 363 sanitize_submodule_env
d851ffb9
JH
364 cd "$sm_path" &&
365 # ash fails to wordsplit ${branch:+-b "$branch"...}
366 case "$branch" in
367 '') git checkout -f -q ;;
368 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
369 esac
370 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
d4264ca3 371 fi
73b0898d 372 git config submodule."$sm_name".url "$realrepo"
d4264ca3 373
64394e3a
RJ
374 git add $force "$sm_path" ||
375 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
ecda0723 376
73b0898d
JL
377 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
378 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
b9289227
TK
379 if test -n "$branch"
380 then
381 git config -f .gitmodules submodule."$sm_name".branch "$branch"
382 fi &&
31991b02 383 git add --force .gitmodules ||
64394e3a 384 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
ecda0723
SV
385}
386
19a31f9c
ML
387#
388# Execute an arbitrary command sequence in each checked out
389# submodule
390#
391# $@ = command to execute
392#
393cmd_foreach()
394{
1d5bec8b
JH
395 # parse $args after "submodule ... foreach".
396 while test $# -ne 0
397 do
398 case "$1" in
399 -q|--quiet)
400 GIT_QUIET=1
401 ;;
15fc56a8
JH
402 --recursive)
403 recursive=1
404 ;;
1d5bec8b
JH
405 -*)
406 usage
407 ;;
408 *)
409 break
410 ;;
411 esac
412 shift
413 done
414
f030c96d
ÆAB
415 toplevel=$(pwd)
416
4dca1aa6
BC
417 # dup stdin so that it can be restored when running the external
418 # command in the subshell (and a recursive call to this function)
419 exec 3<&0
420
74703a1e 421 git submodule--helper list --prefix "$wt_prefix"|
64394e3a 422 while read mode sha1 stage sm_path
19a31f9c 423 do
be9d0a3a 424 die_if_unmatched "$mode"
64394e3a 425 if test -e "$sm_path"/.git
19a31f9c 426 then
091a6eb0
JK
427 displaypath=$(relative_path "$sm_path")
428 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
0ea306ef 429 name=$(git submodule--helper name "$sm_path")
15fc56a8 430 (
64394e3a 431 prefix="$prefix$sm_path/"
14111fc4 432 sanitize_submodule_env
64394e3a 433 cd "$sm_path" &&
091a6eb0
JK
434 sm_path=$(relative_path "$sm_path") &&
435 # we make $path available to scripts ...
436 path=$sm_path &&
1c4fb136
AK
437 if test $# -eq 1
438 then
439 eval "$1"
440 else
441 "$@"
442 fi &&
15fc56a8
JH
443 if test -n "$recursive"
444 then
445 cmd_foreach "--recursive" "$@"
446 fi
4dca1aa6 447 ) <&3 3<&- ||
091a6eb0 448 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
19a31f9c
ML
449 fi
450 done
451}
452
70c7ac22 453#
211b7f19 454# Register submodules in .git/config
70c7ac22
LH
455#
456# $@ = requested paths (default to all)
457#
23a485e3 458cmd_init()
70c7ac22 459{
5c08dbbd
JH
460 # parse $args after "submodule ... init".
461 while test $# -ne 0
462 do
463 case "$1" in
464 -q|--quiet)
2e6a30ef 465 GIT_QUIET=1
5c08dbbd
JH
466 ;;
467 --)
468 shift
469 break
470 ;;
471 -*)
472 usage
473 ;;
474 *)
475 break
476 ;;
477 esac
478 shift
479 done
480
74703a1e 481 git submodule--helper list --prefix "$wt_prefix" "$@" |
64394e3a 482 while read mode sha1 stage sm_path
70c7ac22 483 do
be9d0a3a 484 die_if_unmatched "$mode"
0ea306ef 485 name=$(git submodule--helper name "$sm_path") || exit
c1c259e2 486
091a6eb0
JK
487 displaypath=$(relative_path "$sm_path")
488
c1c259e2 489 # Copy url setting when it is not set yet
2cd9de3e
JL
490 if test -z "$(git config "submodule.$name.url")"
491 then
492 url=$(git config -f .gitmodules submodule."$name".url)
493 test -z "$url" &&
091a6eb0 494 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
2cd9de3e
JL
495
496 # Possibly a url relative to parent
497 case "$url" in
498 ./*|../*)
499 url=$(resolve_relative_url "$url") || exit
500 ;;
501 esac
502 git config submodule."$name".url "$url" ||
091a6eb0 503 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
c1c259e2 504
091a6eb0 505 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
2cd9de3e 506 fi
70c7ac22 507
2cd9de3e 508 # Copy "update" setting when it is not set yet
ac1fbbda
JH
509 if upd="$(git config -f .gitmodules submodule."$name".update)" &&
510 test -n "$upd" &&
511 test -z "$(git config submodule."$name".update)"
512 then
513 case "$upd" in
efa8fd7e 514 checkout | rebase | merge | none)
ac1fbbda
JH
515 ;; # known modes of updating
516 *)
517 echo >&2 "warning: unknown update mode '$upd' suggested for submodule '$name'"
518 upd=none
519 ;;
520 esac
521 git config submodule."$name".update "$upd" ||
522 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
523 fi
70c7ac22
LH
524 done
525}
526
cf419828
JL
527#
528# Unregister submodules from .git/config and remove their work tree
529#
530# $@ = requested paths (use '.' to deinit all submodules)
531#
532cmd_deinit()
533{
534 # parse $args after "submodule ... deinit".
535 while test $# -ne 0
536 do
537 case "$1" in
538 -f|--force)
539 force=$1
540 ;;
541 -q|--quiet)
542 GIT_QUIET=1
543 ;;
544 --)
545 shift
546 break
547 ;;
548 -*)
549 usage
550 ;;
551 *)
552 break
553 ;;
554 esac
555 shift
556 done
557
558 if test $# = 0
559 then
560 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
561 fi
562
74703a1e 563 git submodule--helper list --prefix "$wt_prefix" "$@" |
cf419828
JL
564 while read mode sha1 stage sm_path
565 do
566 die_if_unmatched "$mode"
0ea306ef 567 name=$(git submodule--helper name "$sm_path") || exit
cf419828 568
091a6eb0
JK
569 displaypath=$(relative_path "$sm_path")
570
cf419828
JL
571 # Remove the submodule work tree (unless the user already did it)
572 if test -d "$sm_path"
573 then
574 # Protect submodules containing a .git directory
575 if test -d "$sm_path/.git"
576 then
091a6eb0 577 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
cf419828
JL
578 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
579 fi
580
581 if test -z "$force"
582 then
7b294bf4 583 git rm -qn "$sm_path" ||
091a6eb0 584 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
cf419828 585 fi
7b294bf4 586 rm -rf "$sm_path" &&
091a6eb0
JK
587 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
588 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
cf419828
JL
589 fi
590
091a6eb0 591 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
cf419828
JL
592
593 # Remove the .git/config entries (unless the user already did it)
594 if test -n "$(git config --get-regexp submodule."$name\.")"
595 then
596 # Remove the whole section so we have a clean state when
597 # the user later decides to init this submodule again
598 url=$(git config submodule."$name".url)
599 git config --remove-section submodule."$name" 2>/dev/null &&
091a6eb0 600 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
cf419828
JL
601 fi
602 done
603}
604
70c7ac22 605#
211b7f19 606# Update each submodule path to correct revision, using clone and checkout as needed
70c7ac22
LH
607#
608# $@ = requested paths (default to all)
609#
23a485e3 610cmd_update()
70c7ac22 611{
5c08dbbd
JH
612 # parse $args after "submodule ... update".
613 while test $# -ne 0
614 do
615 case "$1" in
616 -q|--quiet)
2e6a30ef 617 GIT_QUIET=1
5c08dbbd 618 ;;
be4d2c83 619 -i|--init)
d92a3959 620 init=1
be4d2c83 621 ;;
06b1abb5
TK
622 --remote)
623 remote=1
624 ;;
31ca3ac3 625 -N|--no-fetch)
31ca3ac3
FF
626 nofetch=1
627 ;;
9db31bdf
NMC
628 -f|--force)
629 force=$1
630 ;;
ca2cedba 631 -r|--rebase)
32948425 632 update="rebase"
ca2cedba 633 ;;
d92a3959
MT
634 --reference)
635 case "$2" in '') usage ;; esac
636 reference="--reference=$2"
98dbe63d 637 shift
d92a3959
MT
638 ;;
639 --reference=*)
640 reference="$1"
d92a3959 641 ;;
42b49178 642 -m|--merge)
42b49178
JH
643 update="merge"
644 ;;
b13fd5c1 645 --recursive)
b13fd5c1
JH
646 recursive=1
647 ;;
efc5fb6a
JH
648 --checkout)
649 update="checkout"
650 ;;
275cd184
FG
651 --depth)
652 case "$2" in '') usage ;; esac
653 depth="--depth=$2"
654 shift
655 ;;
656 --depth=*)
657 depth=$1
658 ;;
5c08dbbd
JH
659 --)
660 shift
661 break
662 ;;
663 -*)
664 usage
665 ;;
666 *)
667 break
668 ;;
669 esac
98dbe63d 670 shift
5c08dbbd
JH
671 done
672
d92a3959
MT
673 if test -n "$init"
674 then
675 cmd_init "--" "$@" || return
676 fi
677
1b4735d9 678 cloned_modules=
74703a1e 679 git submodule--helper list --prefix "$wt_prefix" "$@" | {
15ffb7cd 680 err=
64394e3a 681 while read mode sha1 stage sm_path
70c7ac22 682 do
be9d0a3a 683 die_if_unmatched "$mode"
313ee0d6
NMC
684 if test "$stage" = U
685 then
75bf5e60 686 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
313ee0d6
NMC
687 continue
688 fi
0ea306ef 689 name=$(git submodule--helper name "$sm_path") || exit
5be60078 690 url=$(git config submodule."$name".url)
d851ffb9 691 branch=$(get_submodule_config "$name" branch master)
efc5fb6a
JH
692 if ! test -z "$update"
693 then
694 update_module=$update
695 else
696 update_module=$(git config submodule."$name".update)
a2aed08b
TK
697 if test -z "$update_module"
698 then
699 update_module="checkout"
700 fi
efc5fb6a
JH
701 fi
702
091a6eb0
JK
703 displaypath=$(relative_path "$prefix$sm_path")
704
d851ffb9
JH
705 if test "$update_module" = "none"
706 then
091a6eb0 707 echo "Skipping submodule '$displaypath'"
efc5fb6a 708 continue
d851ffb9 709 fi
efc5fb6a 710
211b7f19 711 if test -z "$url"
70c7ac22
LH
712 then
713 # Only mention uninitialized submodules when its
714 # path have been specified
715 test "$#" != "0" &&
091a6eb0 716 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
1c2ef66f 717Maybe you want to use 'update --init'?")"
211b7f19
LH
718 continue
719 fi
720
496eeeb1 721 if ! test -d "$sm_path"/.git && ! test -f "$sm_path"/.git
211b7f19 722 then
d10e3b42 723 git submodule--helper clone ${GIT_QUIET:+--quiet} --prefix "$prefix" --path "$sm_path" --name "$name" --url "$url" ${reference:+"$reference"} ${depth:+"$depth"} || exit
1b4735d9 724 cloned_modules="$cloned_modules;$name"
bf2d8246
LH
725 subsha1=
726 else
14111fc4 727 subsha1=$(sanitize_submodule_env; cd "$sm_path" &&
5be60078 728 git rev-parse --verify HEAD) ||
091a6eb0 729 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
70c7ac22 730 fi
211b7f19 731
06b1abb5
TK
732 if test -n "$remote"
733 then
734 if test -z "$nofetch"
735 then
736 # Fetch remote before determining tracking $sha1
14111fc4 737 (sanitize_submodule_env; cd "$sm_path" && git-fetch) ||
06b1abb5
TK
738 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
739 fi
14111fc4
JK
740 remote_name=$(sanitize_submodule_env; cd "$sm_path" && get_default_remote)
741 sha1=$(sanitize_submodule_env; cd "$sm_path" &&
06b1abb5
TK
742 git rev-parse --verify "${remote_name}/${branch}") ||
743 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
744 fi
745
496eeeb1 746 if test "$subsha1" != "$sha1" || test -n "$force"
70c7ac22 747 then
9db31bdf
NMC
748 subforce=$force
749 # If we don't already have a -f flag and the submodule has never been checked out
496eeeb1 750 if test -z "$subsha1" && test -z "$force"
b9b378a0 751 then
9db31bdf 752 subforce="-f"
b9b378a0 753 fi
31ca3ac3
FF
754
755 if test -z "$nofetch"
756 then
e5f522d6
JL
757 # Run fetch only if $sha1 isn't present or it
758 # is not reachable from a ref.
14111fc4 759 (sanitize_submodule_env; cd "$sm_path" &&
f5799e05 760 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
e5f522d6 761 test -z "$rev") || git-fetch)) ||
091a6eb0 762 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
31ca3ac3
FF
763 fi
764
1b4735d9
SO
765 # Is this something we just cloned?
766 case ";$cloned_modules;" in
767 *";$name;"*)
768 # then there is no local change to integrate
d851ffb9 769 update_module=checkout ;;
1b4735d9
SO
770 esac
771
877449c1 772 must_die_on_failure=
32948425 773 case "$update_module" in
a2aed08b
TK
774 checkout)
775 command="git checkout $subforce -q"
776 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
777 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
778 ;;
32948425
JH
779 rebase)
780 command="git rebase"
091a6eb0
JK
781 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
782 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
877449c1 783 must_die_on_failure=yes
32948425 784 ;;
42b49178
JH
785 merge)
786 command="git merge"
091a6eb0
JK
787 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
788 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
877449c1 789 must_die_on_failure=yes
42b49178 790 ;;
6cb5728c
CP
791 !*)
792 command="${update_module#!}"
b80fa842 793 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
6cb5728c
CP
794 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
795 must_die_on_failure=yes
796 ;;
32948425 797 *)
a2aed08b 798 die "$(eval_gettext "Invalid update mode '$update_module' for submodule '$name'")"
32948425 799 esac
70c7ac22 800
14111fc4 801 if (sanitize_submodule_env; cd "$sm_path" && $command "$sha1")
15ffb7cd 802 then
ff968f03 803 say "$say_msg"
877449c1
JH
804 elif test -n "$must_die_on_failure"
805 then
ff968f03 806 die_with_status 2 "$die_msg"
15ffb7cd 807 else
ff968f03 808 err="${err};$die_msg"
877449c1 809 continue
15ffb7cd 810 fi
70c7ac22 811 fi
b13fd5c1
JH
812
813 if test -n "$recursive"
814 then
75bf5e60
WE
815 (
816 prefix="$prefix$sm_path/"
14111fc4 817 sanitize_submodule_env
75bf5e60 818 cd "$sm_path" &&
36141282 819 eval cmd_update
75bf5e60 820 )
15ffb7cd
FG
821 res=$?
822 if test $res -gt 0
823 then
091a6eb0 824 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
15ffb7cd
FG
825 if test $res -eq 1
826 then
ff968f03 827 err="${err};$die_msg"
15ffb7cd
FG
828 continue
829 else
ff968f03 830 die_with_status $res "$die_msg"
15ffb7cd
FG
831 fi
832 fi
b13fd5c1 833 fi
70c7ac22 834 done
15ffb7cd
FG
835
836 if test -n "$err"
837 then
838 OIFS=$IFS
839 IFS=';'
840 for e in $err
841 do
842 if test -n "$e"
843 then
844 echo >&2 "$e"
845 fi
846 done
847 IFS=$OIFS
848 exit 1
849 fi
850 }
70c7ac22
LH
851}
852
bffe71f4
EM
853set_name_rev () {
854 revname=$( (
14111fc4 855 sanitize_submodule_env
bffe71f4 856 cd "$1" && {
5be60078
JH
857 git describe "$2" 2>/dev/null ||
858 git describe --tags "$2" 2>/dev/null ||
f669ac0b
ML
859 git describe --contains "$2" 2>/dev/null ||
860 git describe --all --always "$2"
bffe71f4
EM
861 }
862 ) )
863 test -z "$revname" || revname=" ($revname)"
864}
28f9af5d
PY
865#
866# Show commit summary for submodules in index or working tree
867#
868# If '--cached' is given, show summary between index and given commit,
869# or between working tree and given commit
870#
871# $@ = [commit (default 'HEAD'),] requested paths (default all)
872#
873cmd_summary() {
f2dc06a3 874 summary_limit=-1
d0f64dd4 875 for_status=
1c244f6e 876 diff_cmd=diff-index
f2dc06a3 877
28f9af5d
PY
878 # parse $args after "submodule ... summary".
879 while test $# -ne 0
880 do
881 case "$1" in
882 --cached)
883 cached="$1"
884 ;;
1c244f6e
JL
885 --files)
886 files="$1"
887 ;;
d0f64dd4
PY
888 --for-status)
889 for_status="$1"
890 ;;
f2dc06a3 891 -n|--summary-limit)
862ae6cd
RS
892 summary_limit="$2"
893 isnumber "$summary_limit" || usage
f2dc06a3
PY
894 shift
895 ;;
862ae6cd
RS
896 --summary-limit=*)
897 summary_limit="${1#--summary-limit=}"
898 isnumber "$summary_limit" || usage
899 ;;
28f9af5d
PY
900 --)
901 shift
902 break
903 ;;
904 -*)
905 usage
906 ;;
907 *)
908 break
909 ;;
910 esac
911 shift
912 done
bffe71f4 913
f2dc06a3
PY
914 test $summary_limit = 0 && return
915
3deea89c 916 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
28f9af5d
PY
917 then
918 head=$rev
caa9c3ca 919 test $# = 0 || shift
496eeeb1 920 elif test -z "$1" || test "$1" = "HEAD"
3deea89c 921 then
14e940d7
JH
922 # before the first commit: compare with an empty tree
923 head=$(git hash-object -w -t tree --stdin </dev/null)
2ea6c2c9 924 test -z "$1" || shift
28f9af5d 925 else
3deea89c 926 head="HEAD"
28f9af5d
PY
927 fi
928
1c244f6e
JL
929 if [ -n "$files" ]
930 then
931 test -n "$cached" &&
465d6a00 932 die "$(gettext "The --cached option cannot be used with the --files option")"
1c244f6e
JL
933 diff_cmd=diff-files
934 head=
935 fi
936
28f9af5d 937 cd_to_toplevel
091a6eb0 938 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
28f9af5d 939 # Get modified modules cared by user
18076502 940 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
e1622bfc 941 sane_egrep '^:([0-7]* )?160000' |
2be94509 942 while read mod_src mod_dst sha1_src sha1_dst status sm_path
28f9af5d
PY
943 do
944 # Always show modules deleted or type-changed (blob<->module)
496eeeb1
EP
945 if test "$status" = D || test "$status" = T
946 then
6a066230 947 printf '%s\n' "$sm_path"
496eeeb1
EP
948 continue
949 fi
927b26f8 950 # Respect the ignore setting for --for-status.
951 if test -n "$for_status"
952 then
0ea306ef 953 name=$(git submodule--helper name "$sm_path")
927b26f8 954 ignore_config=$(get_submodule_config "$name" ignore none)
496eeeb1 955 test $status != A && test $ignore_config = all && continue
927b26f8 956 fi
28f9af5d 957 # Also show added or modified modules which are checked out
2be94509 958 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
6a066230 959 printf '%s\n' "$sm_path"
28f9af5d
PY
960 done
961 )
1cb639e6 962
d0f64dd4
PY
963 test -z "$modules" && return
964
18076502 965 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
e1622bfc 966 sane_egrep '^:([0-7]* )?160000' |
1cb639e6
PY
967 cut -c2- |
968 while read mod_src mod_dst sha1_src sha1_dst status name
969 do
970 if test -z "$cached" &&
971 test $sha1_dst = 0000000000000000000000000000000000000000
972 then
973 case "$mod_dst" in
974 160000)
975 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
976 ;;
977 100644 | 100755 | 120000)
978 sha1_dst=$(git hash-object $name)
979 ;;
980 000000)
981 ;; # removed
982 *)
983 # unexpected type
6ff875c5 984 eval_gettextln "unexpected mode \$mod_dst" >&2
1cb639e6
PY
985 continue ;;
986 esac
987 fi
988 missing_src=
989 missing_dst=
990
991 test $mod_src = 160000 &&
30353a40 992 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1cb639e6
PY
993 missing_src=t
994
995 test $mod_dst = 160000 &&
30353a40 996 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1cb639e6 997 missing_dst=t
bffe71f4 998
091a6eb0
JK
999 display_name=$(relative_path "$name")
1000
1cb639e6
PY
1001 total_commits=
1002 case "$missing_src,$missing_dst" in
1003 t,)
091a6eb0 1004 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1cb639e6
PY
1005 ;;
1006 ,t)
091a6eb0 1007 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1cb639e6
PY
1008 ;;
1009 t,t)
091a6eb0 1010 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1cb639e6
PY
1011 ;;
1012 *)
1013 errmsg=
1014 total_commits=$(
496eeeb1 1015 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6
PY
1016 then
1017 range="$sha1_src...$sha1_dst"
1018 elif test $mod_src = 160000
1019 then
1020 range=$sha1_src
1021 else
1022 range=$sha1_dst
1023 fi
1024 GIT_DIR="$name/.git" \
b0e621ad 1025 git rev-list --first-parent $range -- | wc -l
1cb639e6 1026 )
eed35595 1027 total_commits=" ($(($total_commits + 0)))"
1cb639e6
PY
1028 ;;
1029 esac
1030
1031 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1032 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1033 if test $status = T
1034 then
b3e73449
ÆAB
1035 blob="$(gettext "blob")"
1036 submodule="$(gettext "submodule")"
1cb639e6
PY
1037 if test $mod_dst = 160000
1038 then
091a6eb0 1039 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1cb639e6 1040 else
091a6eb0 1041 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1cb639e6
PY
1042 fi
1043 else
091a6eb0 1044 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1cb639e6
PY
1045 fi
1046 if test -n "$errmsg"
1047 then
1048 # Don't give error msg for modification whose dst is not submodule
1049 # i.e. deleted or changed to blob
1050 test $mod_dst = 160000 && echo "$errmsg"
1051 else
496eeeb1 1052 if test $mod_src = 160000 && test $mod_dst = 160000
1cb639e6 1053 then
f2dc06a3
PY
1054 limit=
1055 test $summary_limit -gt 0 && limit="-$summary_limit"
1cb639e6 1056 GIT_DIR="$name/.git" \
f2dc06a3 1057 git log $limit --pretty='format: %m %s' \
1cb639e6
PY
1058 --first-parent $sha1_src...$sha1_dst
1059 elif test $mod_dst = 160000
1060 then
1061 GIT_DIR="$name/.git" \
1062 git log --pretty='format: > %s' -1 $sha1_dst
1063 else
1064 GIT_DIR="$name/.git" \
1065 git log --pretty='format: < %s' -1 $sha1_src
1066 fi
1067 echo
1068 fi
1069 echo
3ba7407b 1070 done
28f9af5d 1071}
70c7ac22 1072#
941987a5 1073# List all submodules, prefixed with:
70c7ac22
LH
1074# - submodule not initialized
1075# + different revision checked out
1076#
1077# If --cached was specified the revision in the index will be printed
1078# instead of the currently checked out revision.
1079#
1080# $@ = requested paths (default to all)
1081#
23a485e3 1082cmd_status()
70c7ac22 1083{
5c08dbbd
JH
1084 # parse $args after "submodule ... status".
1085 while test $# -ne 0
1086 do
1087 case "$1" in
1088 -q|--quiet)
2e6a30ef 1089 GIT_QUIET=1
5c08dbbd
JH
1090 ;;
1091 --cached)
1092 cached=1
1093 ;;
64b19ffe
JH
1094 --recursive)
1095 recursive=1
1096 ;;
5c08dbbd
JH
1097 --)
1098 shift
1099 break
1100 ;;
1101 -*)
1102 usage
1103 ;;
1104 *)
1105 break
1106 ;;
1107 esac
1108 shift
1109 done
1110
74703a1e 1111 git submodule--helper list --prefix "$wt_prefix" "$@" |
64394e3a 1112 while read mode sha1 stage sm_path
70c7ac22 1113 do
be9d0a3a 1114 die_if_unmatched "$mode"
0ea306ef 1115 name=$(git submodule--helper name "$sm_path") || exit
5be60078 1116 url=$(git config submodule."$name".url)
091a6eb0 1117 displaypath=$(relative_path "$prefix$sm_path")
313ee0d6
NMC
1118 if test "$stage" = U
1119 then
1120 say "U$sha1 $displaypath"
1121 continue
1122 fi
496eeeb1
EP
1123 if test -z "$url" ||
1124 {
1125 ! test -d "$sm_path"/.git &&
1126 ! test -f "$sm_path"/.git
1127 }
70c7ac22 1128 then
64b19ffe 1129 say "-$sha1 $displaypath"
70c7ac22
LH
1130 continue;
1131 fi
64394e3a 1132 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
70c7ac22 1133 then
b545cd15 1134 set_name_rev "$sm_path" "$sha1"
64b19ffe 1135 say " $sha1 $displaypath$revname"
70c7ac22
LH
1136 else
1137 if test -z "$cached"
1138 then
14111fc4 1139 sha1=$(sanitize_submodule_env; cd "$sm_path" && git rev-parse --verify HEAD)
70c7ac22 1140 fi
b545cd15 1141 set_name_rev "$sm_path" "$sha1"
64b19ffe
JH
1142 say "+$sha1 $displaypath$revname"
1143 fi
1144
1145 if test -n "$recursive"
1146 then
1147 (
1148 prefix="$displaypath/"
14111fc4 1149 sanitize_submodule_env
64394e3a 1150 cd "$sm_path" &&
e15bec0e 1151 eval cmd_status
64b19ffe 1152 ) ||
64394e3a 1153 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
70c7ac22
LH
1154 fi
1155 done
1156}
2327f61e
DA
1157#
1158# Sync remote urls for submodules
1159# This makes the value for remote.$remote.url match the value
1160# specified in .gitmodules.
1161#
1162cmd_sync()
1163{
1164 while test $# -ne 0
1165 do
1166 case "$1" in
1167 -q|--quiet)
2e6a30ef 1168 GIT_QUIET=1
2327f61e
DA
1169 shift
1170 ;;
82f49f29
PH
1171 --recursive)
1172 recursive=1
1173 shift
1174 ;;
2327f61e
DA
1175 --)
1176 shift
1177 break
1178 ;;
1179 -*)
1180 usage
1181 ;;
1182 *)
1183 break
1184 ;;
1185 esac
1186 done
1187 cd_to_toplevel
74703a1e 1188 git submodule--helper list --prefix "$wt_prefix" "$@" |
64394e3a 1189 while read mode sha1 stage sm_path
2327f61e 1190 do
be9d0a3a 1191 die_if_unmatched "$mode"
0ea306ef 1192 name=$(git submodule--helper name "$sm_path")
2327f61e 1193 url=$(git config -f .gitmodules --get submodule."$name".url)
baede9f8
JH
1194
1195 # Possibly a url relative to parent
1196 case "$url" in
1197 ./*|../*)
967b2c66
JS
1198 # rewrite foo/bar as ../.. to find path from
1199 # submodule work tree to superproject work tree
6a066230 1200 up_path="$(printf '%s\n' "$sm_path" | sed "s/[^/][^/]*/../g")" &&
967b2c66
JS
1201 # guarantee a trailing /
1202 up_path=${up_path%/}/ &&
1203 # path from submodule work tree to submodule origin repo
1204 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1205 # path from superproject work tree to submodule origin repo
1206 super_config_url=$(resolve_relative_url "$url") || exit
1207 ;;
1208 *)
1209 sub_origin_url="$url"
1210 super_config_url="$url"
baede9f8
JH
1211 ;;
1212 esac
1213
ccee6086 1214 if git config "submodule.$name.url" >/dev/null 2>/dev/null
2327f61e 1215 then
091a6eb0
JK
1216 displaypath=$(relative_path "$prefix$sm_path")
1217 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
967b2c66 1218 git config submodule."$name".url "$super_config_url"
ccee6086 1219
64394e3a 1220 if test -e "$sm_path"/.git
ccee6086
JH
1221 then
1222 (
14111fc4 1223 sanitize_submodule_env
64394e3a 1224 cd "$sm_path"
ccee6086 1225 remote=$(get_default_remote)
967b2c66 1226 git config remote."$remote".url "$sub_origin_url"
82f49f29
PH
1227
1228 if test -n "$recursive"
1229 then
1230 prefix="$prefix$sm_path/"
1231 eval cmd_sync
1232 fi
ccee6086
JH
1233 )
1234 fi
2327f61e
DA
1235 fi
1236 done
1237}
70c7ac22 1238
5c08dbbd
JH
1239# This loop parses the command line arguments to find the
1240# subcommand name to dispatch. Parsing of the subcommand specific
1241# options are primarily done by the subcommand implementations.
1242# Subcommand specific options such as --branch and --cached are
1243# parsed here as well, for backward compatibility.
1244
1245while test $# != 0 && test -z "$command"
70c7ac22
LH
1246do
1247 case "$1" in
cf419828 1248 add | foreach | init | deinit | update | status | summary | sync)
5c08dbbd 1249 command=$1
70c7ac22
LH
1250 ;;
1251 -q|--quiet)
2e6a30ef 1252 GIT_QUIET=1
70c7ac22 1253 ;;
ecda0723
SV
1254 -b|--branch)
1255 case "$2" in
1256 '')
1257 usage
1258 ;;
1259 esac
1260 branch="$2"; shift
1261 ;;
70c7ac22 1262 --cached)
28f9af5d 1263 cached="$1"
70c7ac22
LH
1264 ;;
1265 --)
1266 break
1267 ;;
1268 -*)
1269 usage
1270 ;;
1271 *)
1272 break
1273 ;;
1274 esac
1275 shift
1276done
1277
5c08dbbd 1278# No command word defaults to "status"
af9c9f97
RR
1279if test -z "$command"
1280then
1281 if test $# = 0
1282 then
1283 command=status
1284 else
1285 usage
1286 fi
1287fi
5c08dbbd
JH
1288
1289# "-b branch" is accepted only by "add"
1290if test -n "$branch" && test "$command" != add
1291then
ecda0723 1292 usage
5c08dbbd
JH
1293fi
1294
28f9af5d 1295# "--cached" is accepted only by "status" and "summary"
496eeeb1 1296if test -n "$cached" && test "$command" != status && test "$command" != summary
5c08dbbd 1297then
70c7ac22 1298 usage
5c08dbbd
JH
1299fi
1300
1301"cmd_$command" "$@"